commit aa1f683feaccad4a48dd7e543ccfd27de54f2d53
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Wed Jan 13 19:13:42 2016 +0100

    Delete unused GUI classes

diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/element/CdmFormFactory.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/element/CdmFormFactory.java
index 8972e222a..3efeb550a 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/element/CdmFormFactory.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/element/CdmFormFactory.java
@@ -239,9 +239,6 @@ import eu.etaxonomy.taxeditor.ui.section.occurrence.association.TaxonAssociation
 import eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit.PreservedSpecimenCurrentDeterminationDetailSection;
 import eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit.PreservedSpecimenDetailElement;
 import eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit.PreservedSpecimenDetailSection;
-import eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit.PreservedSpecimenDeterminationDetailElement;
-import eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit.PreservedSpecimenDeterminationDetailSection;
-import eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit.PreservedSpecimenDeterminationHistoryDetailSection;
 import eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit.PreservedSpecimenGeneralDetailElement;
 import eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit.PreservedSpecimenGeneralDetailSection;
 import eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit.PreservedSpecimenSourceCollectionDetailSection;
@@ -1783,12 +1780,6 @@ public class CdmFormFactory extends FormToolkit {
         return section;
     }
 
-    public PreservedSpecimenDeterminationDetailSection createPreservedSpecimenDeterminationDetailSection(ConversationHolder conversation, ICdmFormElement parentElement, ISelectionProvider selectionProvider, int style){
-        PreservedSpecimenDeterminationDetailSection section = new PreservedSpecimenDeterminationDetailSection(this, conversation, parentElement, selectionProvider, style);
-        addAndAdaptSection(parentElement, section);
-        return section;
-    }
-
     public TaxonRelationshipDetailSection createTaxonRelationshipDetailSection(ConversationHolder conversation, ICdmFormElement parentElement, ISelectionProvider selectionProvider, int style){
         TaxonRelationshipDetailSection section = new TaxonRelationshipDetailSection(this, conversation, parentElement, selectionProvider, style);
         addAndAdaptSection(parentElement, section);
@@ -2139,12 +2130,6 @@ public class CdmFormFactory extends FormToolkit {
         return element;
     }
 
-    public PreservedSpecimenDeterminationDetailElement createPreservedSpecimenDeterminationDetailElement(ICdmFormElement parentElement) {
-        PreservedSpecimenDeterminationDetailElement element = new PreservedSpecimenDeterminationDetailElement(this, parentElement);
-        addAndAdaptElement(parentElement, element);
-        return element;
-    }
-
     public DeterminationDetailElement createDeterminationDetailElement(ICdmFormElement parentElement) {
         DeterminationDetailElement element = new DeterminationDetailElement(this, parentElement);
         addAndAdaptElement(parentElement, element);
@@ -2383,12 +2368,6 @@ public class CdmFormFactory extends FormToolkit {
         return section;
     }
 
-    public PreservedSpecimenDeterminationHistoryDetailSection createPreservedSpecimenDeterminationHistoryDetailSection(ConversationHolder conversation, ICdmFormElement parentElement, int style){
-        PreservedSpecimenDeterminationHistoryDetailSection section = new PreservedSpecimenDeterminationHistoryDetailSection(this, conversation, parentElement, style);
-        addAndAdaptSection(parentElement, section);
-        return section;
-    }
-
     public SpecimenCollectionDetailSection createSpecimenCollectionDetailSection(ConversationHolder conversation, ICdmFormElement parentElement, int style){
         SpecimenCollectionDetailSection section = new SpecimenCollectionDetailSection(this, conversation, parentElement, style);
         addAndAdaptSection(parentElement, section);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/derivedUnit/PreservedSpecimenDeterminationDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/derivedUnit/PreservedSpecimenDeterminationDetailElement.java
deleted file mode 100644
index 13cbdfd14..000000000
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/derivedUnit/PreservedSpecimenDeterminationDetailElement.java
+++ /dev/null
@@ -1,68 +0,0 @@
-// $Id$
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit;
-
-import org.eclipse.ui.forms.widgets.ExpandableComposite;
-
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
-import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-
-/**
- * @author n.hoffmann
- * @created May 11, 2011
- * @version 1.0
- */
-public class PreservedSpecimenDeterminationDetailElement extends AbstractCdmDetailElement<DerivedUnit> {
-
-	private PreservedSpecimenCurrentDeterminationDetailSection section_currentDetermination;
-
-	private PreservedSpecimenDeterminationHistoryDetailSection section_determinationHistory;
-
-	/**
-	 * @param formFactory
-	 * @param formElement
-	 */
-	public PreservedSpecimenDeterminationDetailElement(CdmFormFactory formFactory,
-			ICdmFormElement formElement) {
-		super(formFactory, formElement);
-	}
-
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement#createControls(eu.etaxonomy.taxeditor.ui.forms.ICdmFormElement, java.lang.Object, int)
-	 */
-	@Override
-	protected void createControls(ICdmFormElement formElement,
-	        DerivedUnit entity, int style) {
-
-        section_currentDetermination = formFactory.createPreservedSpecimenCurrentDeterminationDetailSection(getConversationHolder(), formElement, ExpandableComposite.EXPANDED);
-        section_currentDetermination.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
-        section_currentDetermination.setEntity(entity);
-
-        section_determinationHistory = formFactory.createPreservedSpecimenDeterminationHistoryDetailSection(getConversationHolder(), formElement, ExpandableComposite.TWISTIE);
-        section_determinationHistory.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
-        section_determinationHistory.setEntity(entity);
-
-	}
-
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement#handleEvent(java.lang.Object)
-	 */
-	@Override
-	public void handleEvent(Object eventSource) {
-		if(eventSource == section_currentDetermination){
-			section_determinationHistory.refresh();
-		}
-	}
-
-}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/derivedUnit/PreservedSpecimenDeterminationDetailSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/derivedUnit/PreservedSpecimenDeterminationDetailSection.java
deleted file mode 100644
index 3c4252457..000000000
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/derivedUnit/PreservedSpecimenDeterminationDetailSection.java
+++ /dev/null
@@ -1,58 +0,0 @@
-// $Id$
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit;
-
-import org.eclipse.jface.viewers.ISelectionProvider;
-
-import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
-
-/**
- * @author n.hoffmann
- * @created May 11, 2011
- * @version 1.0
- */
-public class PreservedSpecimenDeterminationDetailSection extends AbstractCdmDetailSection<DerivedUnit> {
-
-	/**
-	 * @param formFactory
-	 * @param conversation
-	 * @param parentElement
-	 * @param selectionProvider
-	 * @param style
-	 */
-	public PreservedSpecimenDeterminationDetailSection(CdmFormFactory formFactory,
-			ConversationHolder conversation, ICdmFormElement parentElement,
-			ISelectionProvider selectionProvider, int style) {
-		super(formFactory, conversation, parentElement, selectionProvider, style);
-	}
-
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection#getHeading()
-	 */
-	@Override
-	public String getHeading() {
-		return "Determinations";
-	}
-
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection#createCdmDetailElement(eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection, int)
-	 */
-	@Override
-	protected AbstractCdmDetailElement<DerivedUnit> createCdmDetailElement(AbstractCdmDetailSection<DerivedUnit> parentElement, int style) {
-	    return formFactory.createPreservedSpecimenDeterminationDetailElement(parentElement);
-	}
-
-}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/derivedUnit/PreservedSpecimenDeterminationHistoryDetailSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/derivedUnit/PreservedSpecimenDeterminationHistoryDetailSection.java
deleted file mode 100644
index f6ce0fc82..000000000
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/derivedUnit/PreservedSpecimenDeterminationHistoryDetailSection.java
+++ /dev/null
@@ -1,76 +0,0 @@
-// $Id$
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.taxeditor.ui.section.occurrence.derivedUnit;
-
-import java.util.Collection;
-import java.util.HashSet;
-import java.util.Set;
-
-import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
-import eu.etaxonomy.cdm.model.occurrence.DeterminationEvent;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-
-/**
- * @author n.hoffmann
- * @created May 11, 2011
- * @version 1.0
- */
-public class PreservedSpecimenDeterminationHistoryDetailSection extends
-PreservedSpecimenAbstractDeterminationEventDetailSection {
-
-	/**
-	 * @param formFactory
-	 * @param conversation
-	 * @param parentElement
-	 * @param style
-	 */
-	public PreservedSpecimenDeterminationHistoryDetailSection(CdmFormFactory formFactory,
-			ConversationHolder conversation, ICdmFormElement parentElement,
-			int style) {
-		super(formFactory, conversation, parentElement, "Determination History", style);
-	}
-
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection#getCollection(java.lang.Object)
-	 */
-	@Override
-	public Collection<DeterminationEvent> getCollection(DerivedUnit entity) {
-	    if(entity!=null){
-	        Set<DeterminationEvent> events = entity.getDeterminations();
-	        Set<DeterminationEvent> result = new HashSet<DeterminationEvent>();
-	        for (DeterminationEvent event : events){
-	            if (event.getPreferredFlag() != true){
-	                result.add(event);
-	            }
-	        }
-	        return result;
-	    }
-		return null;
-	}
-
-	@Override
-	public void refresh() {
-		internalUpdateSection(false);
-	}
-
-
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.taxeditor.section.AbstractEntityCollectionSection#getTooltipString()
-	 */
-	/** {@inheritDoc} */
-	@Override
-	protected String getTooltipString() {
-		return "Add a determination event to the history";
-	}
-
-}